git-repack.shon commit Merge branch 'maint' (e7e5548)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Linus Torvalds
   4#
   5
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git repack [options]
   9--
  10a               pack everything in a single pack
  11A               same as -a, and turn unreachable objects loose
  12d               remove redundant packs, and run git-prune-packed
  13f               pass --no-reuse-object to git-pack-objects
  14n               do not run git-update-server-info
  15q,quiet         be quiet
  16l               pass --local to git-pack-objects
  17 Packing constraints
  18window=         size of the window used for delta compression
  19window-memory=  same as the above, but limit memory size instead of entries count
  20depth=          limits the maximum delta depth
  21max-pack-size=  maximum size of each packfile
  22"
  23SUBDIRECTORY_OK='Yes'
  24. git-sh-setup
  25
  26no_update_info= all_into_one= remove_redundant= unpack_unreachable=
  27local= no_reuse= extra=
  28while test $# != 0
  29do
  30        case "$1" in
  31        -n)     no_update_info=t ;;
  32        -a)     all_into_one=t ;;
  33        -A)     all_into_one=t
  34                unpack_unreachable=--unpack-unreachable ;;
  35        -d)     remove_redundant=t ;;
  36        -q)     GIT_QUIET=t ;;
  37        -f)     no_reuse=--no-reuse-object ;;
  38        -l)     local=--local ;;
  39        --max-pack-size|--window|--window-memory|--depth)
  40                extra="$extra $1=$2"; shift ;;
  41        --) shift; break;;
  42        *)      usage ;;
  43        esac
  44        shift
  45done
  46
  47case "`git config --bool repack.usedeltabaseoffset || echo true`" in
  48true)
  49        extra="$extra --delta-base-offset" ;;
  50esac
  51
  52PACKDIR="$GIT_OBJECT_DIRECTORY/pack"
  53PACKTMP="$GIT_OBJECT_DIRECTORY/.tmp-$$-pack"
  54rm -f "$PACKTMP"-*
  55trap 'rm -f "$PACKTMP"-*' 0 1 2 3 15
  56
  57# There will be more repacking strategies to come...
  58case ",$all_into_one," in
  59,,)
  60        args='--unpacked --incremental'
  61        ;;
  62,t,)
  63        args= existing=
  64        if [ -d "$PACKDIR" ]; then
  65                for e in `cd "$PACKDIR" && find . -type f -name '*.pack' \
  66                        | sed -e 's/^\.\///' -e 's/\.pack$//'`
  67                do
  68                        if [ -e "$PACKDIR/$e.keep" ]; then
  69                                : keep
  70                        else
  71                                existing="$existing $e"
  72                        fi
  73                done
  74                if test -n "$existing" -a -n "$unpack_unreachable" -a \
  75                        -n "$remove_redundant"
  76                then
  77                        args="$args $unpack_unreachable"
  78                fi
  79        fi
  80        ;;
  81esac
  82
  83args="$args $local ${GIT_QUIET:+-q} $no_reuse$extra"
  84names=$(git pack-objects --keep-true-parents --honor-pack-keep --non-empty --all --reflog $args </dev/null "$PACKTMP") ||
  85        exit 1
  86if [ -z "$names" ]; then
  87        say Nothing new to pack.
  88fi
  89
  90# Ok we have prepared all new packfiles.
  91mkdir -p "$PACKDIR" || exit
  92
  93# First see if there are packs of the same name and if so
  94# if we can move them out of the way (this can happen if we
  95# repacked immediately after packing fully.
  96rollback=
  97failed=
  98for name in $names
  99do
 100        for sfx in pack idx
 101        do
 102                file=pack-$name.$sfx
 103                test -f "$PACKDIR/$file" || continue
 104                rm -f "$PACKDIR/old-$file" &&
 105                mv "$PACKDIR/$file" "$PACKDIR/old-$file" || {
 106                        failed=t
 107                        break
 108                }
 109                rollback="$rollback $file"
 110        done
 111        test -z "$failed" || break
 112done
 113
 114# If renaming failed for any of them, roll the ones we have
 115# already renamed back to their original names.
 116if test -n "$failed"
 117then
 118        rollback_failure=
 119        for file in $rollback
 120        do
 121                mv "$PACKDIR/old-$file" "$PACKDIR/$file" ||
 122                rollback_failure="$rollback_failure $file"
 123        done
 124        if test -n "$rollback_failure"
 125        then
 126                echo >&2 "WARNING: Some packs in use have been renamed by"
 127                echo >&2 "WARNING: prefixing old- to their name, in order to"
 128                echo >&2 "WARNING: replace them with the new version of the"
 129                echo >&2 "WARNING: file.  But the operation failed, and"
 130                echo >&2 "WARNING: attempt to rename them back to their"
 131                echo >&2 "WARNING: original names also failed."
 132                echo >&2 "WARNING: Please rename them in $PACKDIR manually:"
 133                for file in $rollback_failure
 134                do
 135                        echo >&2 "WARNING:   old-$file -> $file"
 136                done
 137        fi
 138        exit 1
 139fi
 140
 141# Now the ones with the same name are out of the way...
 142fullbases=
 143for name in $names
 144do
 145        fullbases="$fullbases pack-$name"
 146        chmod a-w "$PACKTMP-$name.pack"
 147        chmod a-w "$PACKTMP-$name.idx"
 148        mv -f "$PACKTMP-$name.pack" "$PACKDIR/pack-$name.pack" &&
 149        mv -f "$PACKTMP-$name.idx"  "$PACKDIR/pack-$name.idx" ||
 150        exit
 151done
 152
 153# Remove the "old-" files
 154for name in $names
 155do
 156        rm -f "$PACKDIR/old-pack-$name.idx"
 157        rm -f "$PACKDIR/old-pack-$name.pack"
 158done
 159
 160# End of pack replacement.
 161
 162if test "$remove_redundant" = t
 163then
 164        # We know $existing are all redundant.
 165        if [ -n "$existing" ]
 166        then
 167                ( cd "$PACKDIR" &&
 168                  for e in $existing
 169                  do
 170                        case " $fullbases " in
 171                        *" $e "*) ;;
 172                        *)      rm -f "$e.pack" "$e.idx" "$e.keep" ;;
 173                        esac
 174                  done
 175                )
 176        fi
 177        git prune-packed ${GIT_QUIET:+-q}
 178fi
 179
 180case "$no_update_info" in
 181t) : ;;
 182*) git update-server-info ;;
 183esac